#include"f_MakeupBase.h"
#include"f_LipsRecolor.h"
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include"Commen.h"
#include"f_AffineTransfrom.h"
#include "opencv4/opencv2/opencv.hpp"

#include<stdlib.h>
#include<iostream>
#include <Poco/Stopwatch.h>
#include "Poco/Net/HTTPSClientSession.h"
#include <Poco/URI.h>
#include <Poco/StreamCopier.h>
#include <Poco/Net/HTTPRequest.h>
#include <Poco/Net/HTMLForm.h>
#include <Poco/Net/HTTPResponse.h>
#include "Poco/JSON/Parser.h"
#include "Poco/Dynamic/Var.h"
#include "ZBase64.h"
#include "fstream"
#include <opencv2/opencv.hpp>
#include <opencv2/dnn.hpp>
#include <opencv2/imgcodecs/legacy/constants_c.h>
using namespace cv;
using namespace Poco;
using namespace Poco::Net;
using namespace std;

inline void computeOutRectInfo(int points[], int pointNum, int outPoints[2 * 8])
{
	int minx = 10000, maxx = 0, miny = 10000, maxy = 0;
	for(int i = 0; i < pointNum; i++)
	{
		minx = MIN2(minx, points[2 * i]);
		miny = MIN2(miny, points[2 * i + 1]);
		maxx = MAX2(maxx, points[2 * i]);
		maxy = MAX2(maxy, points[2 * i + 1]);
	}
	int w = maxx - minx;
	int h = maxy - miny;
	minx = minx - w / 5;
	miny = miny - h / 5;
	maxx = maxx + w / 5;
	maxy = maxy + h / 5;
	outPoints[0] = minx;
	outPoints[1] = miny;
	outPoints[2] = minx;
	outPoints[3] = miny + h / 2;
	outPoints[4] = minx;
	outPoints[5] = maxy;
	outPoints[6] = minx + w / 2;
	outPoints[7] = maxy;
	outPoints[8] = maxx;
	outPoints[9] = maxy;
	outPoints[10] = maxx;
	outPoints[11] = miny + h / 2;
	outPoints[12] = maxx;
	outPoints[13] = miny;
	outPoints[14] = minx + w / 2;
	outPoints[15] = miny;
};
//compute squares of triangle
inline float GetTriangleSquar(float pt0_x, float pt0_y, float pt1_x, float pt1_y, float pt2_x, float pt2_y)  
{  
    float AB_x, AB_y, BC_x, BC_y;      
    AB_x = pt1_x - pt0_x;     
    AB_y = pt1_y - pt0_y;     
    BC_x = pt2_x - pt1_x;     
    BC_y = pt2_y - pt1_y;       
    return abs((AB_x * BC_y - AB_y * BC_x)) * 0.5f;      
}  
//judge the point is in the triangle or not.
inline bool JudgePointInTriangleOrNot(float curPoint_x, float curPoint_y, float Ax, float Ay, float Bx, float By, float Cx, float Cy)
{	  
    float ABS_FLOAT_0 = 0.0001;
	float SABC, SADB, SBDC, SADC;  
    SABC = GetTriangleSquar(Ax,Ay, Bx, By, Cx, Cy);  
    SADB = GetTriangleSquar(Ax,Ay, curPoint_x, curPoint_y, Bx, By);  
    SBDC = GetTriangleSquar(Bx,By, curPoint_x, curPoint_y, Cx, Cy);  
    SADC = GetTriangleSquar(Ax,Ay, curPoint_x, curPoint_y, Cx, Cy);   
    float SumSuqar = SADB + SBDC + SADC;  
    if ((-ABS_FLOAT_0 < (SABC - SumSuqar)) && ((SABC - SumSuqar) < ABS_FLOAT_0))  
    {  
        return true;  
    }  
    else  
    {  
        return false;  
    }  
}
/*************************************************************************
*Function: Lips recolor
*Params:
*srcData:32BGRA image buffer
*width:  width of image
*height: height of image
*stride: Stride of image
*srcFacePoints: 101 face points.
*mskData: Lips image mask buffer with format bgra32
*mWidth: width of mask image 
*mHeight: height of mask image
*mStride: Stride of mask image
*maskKeyPoints: 28 key points of lips mask.
*isLeft: left or right face.
*ratio: intensity of effect, [0, 100]
*Return: 0-OK,other failed
**************************************************************************/
int f_LipsRecolor(unsigned char* srcData, int width, int height, int stride, int srcFacePoints[202], unsigned char* mskData, int mWidth, int mHeight, int mStride, int maskKeyPoints[2 * 28], unsigned char* lipsColorMap,  int ratio)
{
	int ret = 0;
	////compute 28 points of lips for srcData
	int srcLipsPoints[2 * 28] = {0};
	for(int i = 0; i < 2 * 20; i++)
	{
		srcLipsPoints[i] = srcFacePoints[2 * 75 + i];
	}
	int srcRectInfo[2 * 8] = {0};
	computeOutRectInfo(srcLipsPoints, 20, srcRectInfo);
	for(int i = 0; i < 2 * 8; i++)
	{
		srcLipsPoints[2 * 20 + i] = srcRectInfo[i];
	}
	///42 TRIANGLES
	const int TRIANGLE_NUM = 42;
	int TRIANGLE_INDEX[3 * TRIANGLE_NUM] = {20, 21, 1, 1, 21, 0, 0, 21, 11, 11, 21, 22, 11, 22, 23, 11, 23, 10, 10,23, 9, 9, 23, 8, 8, 23, 7, 7, 23, 24, 7, 24, 25, 7, 25, 6, 6, 25, 5, 5, 25, 26, 5, 26, 27, 5, 27, 4, 4, 27, 3, 3, 27, 2, 2, 27, 1, 1, 27, 20, 
	0, 11, 19, 19, 11, 10, 19, 10, 18, 18, 10, 9, 18, 9, 8, 18, 8, 17, 17, 8, 7, 7, 6, 17, 6, 5, 15, 15, 5, 4, 15, 4, 14, 14, 4, 3, 14, 3, 2, 14, 2, 13, 13, 2, 1, 13, 1, 0,
	0, 19, 13, 13, 19, 18, 13, 18, 14, 14, 18, 15, 15, 18, 17, 15, 17, 6};
	unsigned char* label = (unsigned char*)malloc(sizeof(unsigned char) * width * height);
	memset(label, 0, sizeof(unsigned char) * width * height);
	for(int i = 0; i < TRIANGLE_NUM; i++)
	{
		float H[6] = {0};
		f_AffinetransformMetrixCompute(maskKeyPoints[2 * TRIANGLE_INDEX[3 * i]],maskKeyPoints[2 * TRIANGLE_INDEX[3 * i] + 1], maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 1]],maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 1] + 1], maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 2]], maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 2] + 1], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i]], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i] + 1], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 1]], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 1] + 1],srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 2]],srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 2] + 1], H);
		int px = MIN2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i]], MIN2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 1]], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 2]]));
	    int py = MIN2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i] + 1], MIN2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 1] + 1], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 2] + 1]));
	    int mw = (int)(MAX2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i]],MAX2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 1]], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 2]])) - px);
	    int mh = (int)(MAX2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i] + 1],MAX2(srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 1] + 1], srcLipsPoints[2 * TRIANGLE_INDEX[3 * i + 2] + 1])) - py);
		px = px - 1;
		py = py - 1;
		mw = mw + 2;
		mh = mh + 2;
		for(int n = 0; n < mh; n++)
		{
			for(int m = 0; m < mw; m++)
			{
				int cx = m + px;
				int cy = n + py;
				if(label[cx + cy * width] > 0)
					continue;
				int pos = cx * 4 + cy * stride;
				float x0 = (H[0] * cx + H[1] * cy + H[2]);
	            float y0 = (H[3] * cx + H[4] * cy + H[5]);
				bool isIn = JudgePointInTriangleOrNot(x0, y0, maskKeyPoints[2 * TRIANGLE_INDEX[3 * i]],maskKeyPoints[2 * TRIANGLE_INDEX[3 * i] + 1], maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 1]],maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 1] + 1], maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 2]], maskKeyPoints[2 * TRIANGLE_INDEX[3 * i + 2] + 1]); 
			    if(isIn)
				{
					//get alpha for blend
					int msk_b = mskData[(int)x0 * 4 + (int)y0 * mStride];
					int msk_g = mskData[(int)x0 * 4 + (int)y0 * mStride + 1];
					int msk_r = mskData[(int)x0 * 4 + (int)y0 * mStride + 2];
					int b = srcData[pos];
					int g = srcData[pos + 1];
					int r = srcData[pos + 2];
					int gray = (msk_b + msk_g + msk_r) / 3;
					//lips recolored using 512 lut
					int k  =  (b  >>  2);
                    int nx  =  (int)(r  >>  2)  +  ((k  -  ((k  >>  3)  <<  3))  <<  6);
                    int ny  =  (int)(((b  >>  5)  <<  6)  +  (g  >>  2));
                    int mpos  =  (nx * 4)  +  (ny * 512 * 4);
					int mb = lipsColorMap[mpos];
					int mg = lipsColorMap[mpos + 1];
					int mr = lipsColorMap[mpos + 2];
					//lips and color blend by alpha
					mb = CLIP3((b * (255 - gray) + mb * gray) / 255, 0, 255);
					mg = CLIP3((g * (255 - gray) + mg * gray) / 255, 0, 255);
					mr = CLIP3((r * (255 - gray) + mr * gray) / 255, 0, 255);
					//color intensity blending
					srcData[pos] = (mb * ratio + b * (100 - ratio)) / 100;
					srcData[pos + 1] = (mg * ratio + g * (100 - ratio)) / 100;
					srcData[pos + 2] = (mr * ratio + r * (100 - ratio)) / 100;
					label[cx + cy * width] = 255;
				}
				
			}
		}
	}
	free(label);
	return ret;
};


void f_LipsRecolor(unsigned char* srcData, int width, int height, int stride, int srcFacePoints[202], unsigned char* lipsColorMap,  int ratio)
{
    for(int n = 0; n < height; n++)
    {
        for(int m = 0; m < width; m++)
        {
            bool isIn = true;
            if(isIn)
            {
                //get alpha for blend
                int pos = width*n + m*stride;
                int b = srcData[pos];
                int g = srcData[pos + 1];
                int r = srcData[pos + 2];
                //lips recolored using 512 lut
                int k  =  (b  >>  2);
                int nx  =  (int)(r  >>  2)  +  ((k  -  ((k  >>  3)  <<  3))  <<  6);
                int ny  =  (int)(((b  >>  5)  <<  6)  +  (g  >>  2));
                int mpos  =  (nx * 4)  +  (ny * 512 * 4);
                int mb = lipsColorMap[mpos];
                int mg = lipsColorMap[mpos + 1];
                int mr = lipsColorMap[mpos + 2];
                //lips and color blend by alpha
                mb = CLIP3(b, 0, 255);
                mg = CLIP3(g, 0, 255);
                mr = CLIP3(r, 0, 255);
                //color intensity blending
                srcData[pos] = (mb * ratio + b * (100 - ratio)) / 100;
                srcData[pos + 1] = (mg * ratio + g * (100 - ratio)) / 100;
                srcData[pos + 2] = (mr * ratio + r * (100 - ratio)) / 100;
            }

        }
    }
};


void trans2Mat(string& filePath,cv::Mat& lipsLut)
{
    vector<unsigned char> data;
    ifstream ifs(filePath,ios::binary);
    char buf[1024];
    while(ifs.read(buf, sizeof(buf))){
        streamsize gcount = ifs.gcount();
        for (int i = 0; i < gcount; ++i){
            data.push_back(buf[i]);
        }
    }
    streamsize gcount = ifs.gcount();
    if(gcount>0){
        for (int i = 0; i < gcount; ++i){
            data.push_back(buf[i]);
        }
    }
    lipsLut = cv::imdecode(data,CV_LOAD_IMAGE_COLOR);
    ifs.close();
}


#include <dirent.h>
#include "Poco/StringTokenizer.h"

void loadLipLut(map<int,cv::Mat>& lipsLutMap,string& baseDir)
{
    DIR* dir = opendir(baseDir.c_str());//打开指定目录
    dirent* p = NULL;//定义遍历指针
    while((p = readdir(dir)) != NULL)//开始逐个遍历
    {
        //这里需要注意，linux平台下一个目录中有"."和".."隐藏文件，需要过滤掉
        if(p->d_name[0] != '.')//d_name是一个char数组，存放当前遍历到的文件名
        {
            string name = string(p->d_name);
            cout<<name<<endl;
            Poco::StringTokenizer stringTokenizer(name,".");
            cout << stringTokenizer[0] << endl;
            lipsLutMap[stoi(stringTokenizer[0])] = cv::imread(baseDir+name);
        }
    }
    closedir(dir);//关闭指定目录
}

int main99(int argc, char* argv[])
{
    map<int,cv::Mat> lipsLutMap;

    //加载lipLUT模板
    string baseDir = "/Users/edz/CLionProjects/AI_Face/lipsLUT/";
    loadLipLut(lipsLutMap,baseDir);

    int mtIndex = stoi(string(argv[1]));

    string photoFilePath = "/Users/edz/CLionProjects/AI_Face/自然唇.png";
//    string photoFilePath = "/Users/edz/Downloads/合集/模特/自然唇.png";

    //计时
    Poco::Stopwatch stopwatch;
    stopwatch.start();
    //获取人脸1000关键点
    URI uri("https://api-cn.faceplusplus.com/facepp/v1/face/thousandlandmark");
    const Poco::Net::Context::Ptr context(
            new Poco::Net::Context(Poco::Net::Context::CLIENT_USE, "", "", "",
                                   Poco::Net::Context::VERIFY_NONE));
    Poco::Net::HTTPSClientSession session(uri.getHost(), uri.getPort(), context);
    HTTPRequest es_request(HTTPRequest::HTTP_POST,uri.getPathAndQuery(),HTTPRequest::HTTP_1_1);
    es_request.setContentType("multipart/form-data");
    HTMLForm form;
    form.setEncoding(HTMLForm::ENCODING_MULTIPART);
    form.add("api_key", "-6zs61jR1M4GqzE9jIO3eiL1W1sojaeE");
    form.add("api_secret", "J82yKgSplMDppw9oPpHeTVTA4hYxp0iB");
    form.add("return_landmark", "mouth");
    //图片base64编码
    //读取图片,获得字节数组和Mat
    vector<unsigned char> data;
    ifstream ifs(photoFilePath,ios::binary);
    if(ifs.is_open()){
        char buf[1024];
        while(ifs.read(buf, sizeof(buf))){
            streamsize gcount = ifs.gcount();
            for (int i = 0; i < gcount; ++i){
                data.push_back(buf[i]);
            }
        }
        streamsize gcount = ifs.gcount();
        if(gcount>0){
            for (int i = 0; i < gcount; ++i){
                data.push_back(buf[i]);
            }
        }
        cv::Mat mat = cv::imdecode(data,CV_LOAD_IMAGE_COLOR);
        unsigned char tmp[data.size()];
        for (int i = 0; i < data.size(); ++i){
            tmp[i] = data.at(i);
        }
        ZBase64 zBase64;
        string base64Str;
        zBase64.Encode(tmp,data.size(),base64Str);
        form.add("image_base64",base64Str);
        form.prepareSubmit(es_request);
        form.write(session.sendRequest(es_request));
        HTTPResponse es_response;
        std::istream &istream = session.receiveResponse(es_response);
        const HTTPResponse::HTTPStatus &status = es_response.getStatus();
        if(HTTPResponse::HTTPStatus::HTTP_OK == status) {
//        if(true) {
            std::string stRes;
            StreamCopier::copyToString(istream, stRes);
            std::cout << stRes << std::endl;
//            string stRes = "{\"time_used\": 155, \"request_id\": \"1618825817,bbcc62bb-db7b-4f65-ac74-8c3c408f27c6\", \"face\": {\"landmark\": {\"right_eyebrow\": {\"right_eyebrow_56\": {\"y\": 363, \"x\": 529}, \"right_eyebrow_57\": {\"y\": 363, \"x\": 532}, \"right_eyebrow_54\": {\"y\": 362, \"x\": 523}, \"right_eyebrow_55\": {\"y\": 362, \"x\": 526}, \"right_eyebrow_38\": {\"y\": 366, \"x\": 477}, \"right_eyebrow_39\": {\"y\": 365, \"x\": 480}, \"right_eyebrow_50\": {\"y\": 362, \"x\": 512}, \"right_eyebrow_51\": {\"y\": 362, \"x\": 514}, \"right_eyebrow_34\": {\"y\": 365, \"x\": 465}, \"right_eyebrow_35\": {\"y\": 366, \"x\": 468}, \"right_eyebrow_36\": {\"y\": 366, \"x\": 471}, \"right_eyebrow_37\": {\"y\": 366, \"x\": 474}, \"right_eyebrow_30\": {\"y\": 355, \"x\": 465}, \"right_eyebrow_31\": {\"y\": 358, \"x\": 464}, \"right_eyebrow_32\": {\"y\": 361, \"x\": 463}, \"right_eyebrow_33\": {\"y\": 364, \"x\": 464}, \"right_eyebrow_12\": {\"y\": 349, \"x\": 520}, \"right_eyebrow_13\": {\"y\": 349, \"x\": 517}, \"right_eyebrow_10\": {\"y\": 350, \"x\": 527}, \"right_eyebrow_11\": {\"y\": 349, \"x\": 524}, \"right_eyebrow_16\": {\"y\": 349, \"x\": 508}, \"right_eyebrow_17\": {\"y\": 349, \"x\": 505}, \"right_eyebrow_14\": {\"y\": 349, \"x\": 514}, \"right_eyebrow_15\": {\"y\": 349, \"x\": 511}, \"right_eyebrow_52\": {\"y\": 362, \"x\": 517}, \"right_eyebrow_18\": {\"y\": 349, \"x\": 502}, \"right_eyebrow_19\": {\"y\": 349, \"x\": 499}, \"right_eyebrow_53\": {\"y\": 362, \"x\": 520}, \"right_eyebrow_44\": {\"y\": 363, \"x\": 494}, \"right_eyebrow_41\": {\"y\": 364, \"x\": 485}, \"right_eyebrow_58\": {\"y\": 363, \"x\": 535}, \"right_eyebrow_40\": {\"y\": 365, \"x\": 482}, \"right_eyebrow_43\": {\"y\": 364, \"x\": 491}, \"right_eyebrow_49\": {\"y\": 362, \"x\": 509}, \"right_eyebrow_48\": {\"y\": 362, \"x\": 506}, \"right_eyebrow_61\": {\"y\": 365, \"x\": 543}, \"right_eyebrow_42\": {\"y\": 364, \"x\": 488}, \"right_eyebrow_29\": {\"y\": 354, \"x\": 468}, \"right_eyebrow_28\": {\"y\": 352, \"x\": 471}, \"right_eyebrow_27\": {\"y\": 352, \"x\": 474}, \"right_eyebrow_26\": {\"y\": 351, \"x\": 477}, \"right_eyebrow_25\": {\"y\": 351, \"x\": 480}, \"right_eyebrow_24\": {\"y\": 350, \"x\": 483}, \"right_eyebrow_23\": {\"y\": 350, \"x\": 486}, \"right_eyebrow_22\": {\"y\": 350, \"x\": 489}, \"right_eyebrow_21\": {\"y\": 350, \"x\": 492}, \"right_eyebrow_20\": {\"y\": 349, \"x\": 495}, \"right_eyebrow_59\": {\"y\": 364, \"x\": 538}, \"right_eyebrow_47\": {\"y\": 363, \"x\": 503}, \"right_eyebrow_60\": {\"y\": 365, \"x\": 541}, \"right_eyebrow_46\": {\"y\": 363, \"x\": 500}, \"right_eyebrow_45\": {\"y\": 363, \"x\": 497}, \"right_eyebrow_8\": {\"y\": 352, \"x\": 533}, \"right_eyebrow_9\": {\"y\": 351, \"x\": 530}, \"right_eyebrow_0\": {\"y\": 366, \"x\": 552}, \"right_eyebrow_1\": {\"y\": 363, \"x\": 551}, \"right_eyebrow_2\": {\"y\": 361, \"x\": 549}, \"right_eyebrow_3\": {\"y\": 359, \"x\": 546}, \"right_eyebrow_4\": {\"y\": 357, \"x\": 544}, \"right_eyebrow_5\": {\"y\": 355, \"x\": 541}, \"right_eyebrow_6\": {\"y\": 354, \"x\": 538}, \"right_eyebrow_7\": {\"y\": 353, \"x\": 536}, \"right_eyebrow_62\": {\"y\": 366, \"x\": 546}, \"right_eyebrow_63\": {\"y\": 367, \"x\": 549}}, \"left_eyebrow\": {\"left_eyebrow_54\": {\"y\": 361, \"x\": 331}, \"left_eyebrow_55\": {\"y\": 361, \"x\": 329}, \"left_eyebrow_52\": {\"y\": 361, \"x\": 337}, \"left_eyebrow_53\": {\"y\": 361, \"x\": 334}, \"left_eyebrow_50\": {\"y\": 361, \"x\": 343}, \"left_eyebrow_51\": {\"y\": 361, \"x\": 340}, \"left_eyebrow_56\": {\"y\": 362, \"x\": 326}, \"left_eyebrow_57\": {\"y\": 362, \"x\": 323}, \"left_eyebrow_18\": {\"y\": 349, \"x\": 352}, \"left_eyebrow_19\": {\"y\": 349, \"x\": 356}, \"left_eyebrow_16\": {\"y\": 349, \"x\": 346}, \"left_eyebrow_17\": {\"y\": 349, \"x\": 349}, \"left_eyebrow_14\": {\"y\": 348, \"x\": 340}, \"left_eyebrow_15\": {\"y\": 348, \"x\": 343}, \"left_eyebrow_12\": {\"y\": 349, \"x\": 334}, \"left_eyebrow_13\": {\"y\": 349, \"x\": 337}, \"left_eyebrow_10\": {\"y\": 349, \"x\": 328}, \"left_eyebrow_11\": {\"y\": 349, \"x\": 331}, \"left_eyebrow_34\": {\"y\": 364, \"x\": 389}, \"left_eyebrow_35\": {\"y\": 365, \"x\": 386}, \"left_eyebrow_36\": {\"y\": 365, \"x\": 383}, \"left_eyebrow_37\": {\"y\": 365, \"x\": 380}, \"left_eyebrow_30\": {\"y\": 354, \"x\": 388}, \"left_eyebrow_31\": {\"y\": 357, \"x\": 390}, \"left_eyebrow_32\": {\"y\": 360, \"x\": 391}, \"left_eyebrow_33\": {\"y\": 363, \"x\": 390}, \"left_eyebrow_38\": {\"y\": 365, \"x\": 378}, \"left_eyebrow_39\": {\"y\": 364, \"x\": 375}, \"left_eyebrow_4\": {\"y\": 355, \"x\": 311}, \"left_eyebrow_5\": {\"y\": 354, \"x\": 313}, \"left_eyebrow_6\": {\"y\": 352, \"x\": 316}, \"left_eyebrow_7\": {\"y\": 351, \"x\": 319}, \"left_eyebrow_0\": {\"y\": 364, \"x\": 303}, \"left_eyebrow_1\": {\"y\": 361, \"x\": 304}, \"left_eyebrow_2\": {\"y\": 359, \"x\": 306}, \"left_eyebrow_3\": {\"y\": 357, \"x\": 308}, \"left_eyebrow_8\": {\"y\": 350, \"x\": 322}, \"left_eyebrow_9\": {\"y\": 350, \"x\": 325}, \"left_eyebrow_45\": {\"y\": 362, \"x\": 358}, \"left_eyebrow_44\": {\"y\": 363, \"x\": 360}, \"left_eyebrow_47\": {\"y\": 362, \"x\": 352}, \"left_eyebrow_46\": {\"y\": 362, \"x\": 355}, \"left_eyebrow_41\": {\"y\": 364, \"x\": 369}, \"left_eyebrow_40\": {\"y\": 364, \"x\": 372}, \"left_eyebrow_43\": {\"y\": 363, \"x\": 363}, \"left_eyebrow_42\": {\"y\": 363, \"x\": 366}, \"left_eyebrow_63\": {\"y\": 364, \"x\": 305}, \"left_eyebrow_62\": {\"y\": 364, \"x\": 308}, \"left_eyebrow_61\": {\"y\": 363, \"x\": 311}, \"left_eyebrow_60\": {\"y\": 363, \"x\": 314}, \"left_eyebrow_49\": {\"y\": 362, \"x\": 346}, \"left_eyebrow_48\": {\"y\": 362, \"x\": 349}, \"left_eyebrow_27\": {\"y\": 351, \"x\": 380}, \"left_eyebrow_26\": {\"y\": 350, \"x\": 377}, \"left_eyebrow_25\": {\"y\": 350, \"x\": 374}, \"left_eyebrow_24\": {\"y\": 350, \"x\": 371}, \"left_eyebrow_23\": {\"y\": 349, \"x\": 368}, \"left_eyebrow_22\": {\"y\": 349, \"x\": 365}, \"left_eyebrow_21\": {\"y\": 349, \"x\": 362}, \"left_eyebrow_20\": {\"y\": 349, \"x\": 359}, \"left_eyebrow_58\": {\"y\": 362, \"x\": 320}, \"left_eyebrow_29\": {\"y\": 353, \"x\": 386}, \"left_eyebrow_28\": {\"y\": 352, \"x\": 383}, \"left_eyebrow_59\": {\"y\": 363, \"x\": 317}}}, \"face_rectangle\": {\"width\": 301, \"top\": 342, \"height\": 300, \"left\": 280}}}";
//            string stRes = "{\"time_used\": 189, \"request_id\": \"1625051282,d64421fc-35f6-4ce8-86ee-aa686e3ff42d\", \"face\": {\"landmark\": {\"mouth\": {\"lower_lip_39\": {\"y\": 317, \"x\": 243}, \"lower_lip_38\": {\"y\": 317, \"x\": 245}, \"lower_lip_35\": {\"y\": 316, \"x\": 251}, \"lower_lip_34\": {\"y\": 315, \"x\": 254}, \"lower_lip_37\": {\"y\": 316, \"x\": 247}, \"lower_lip_36\": {\"y\": 316, \"x\": 249}, \"lower_lip_31\": {\"y\": 314, \"x\": 260}, \"lower_lip_30\": {\"y\": 316, \"x\": 260}, \"lower_lip_33\": {\"y\": 315, \"x\": 256}, \"lower_lip_32\": {\"y\": 315, \"x\": 258}, \"lower_lip_48\": {\"y\": 319, \"x\": 222}, \"lower_lip_49\": {\"y\": 319, \"x\": 220}, \"lower_lip_40\": {\"y\": 317, \"x\": 240}, \"lower_lip_41\": {\"y\": 318, \"x\": 238}, \"lower_lip_42\": {\"y\": 318, \"x\": 236}, \"lower_lip_43\": {\"y\": 319, \"x\": 234}, \"lower_lip_44\": {\"y\": 319, \"x\": 231}, \"lower_lip_45\": {\"y\": 320, \"x\": 229}, \"lower_lip_46\": {\"y\": 320, \"x\": 227}, \"lower_lip_47\": {\"y\": 320, \"x\": 225}, \"upper_lip_0\": {\"y\": 312, \"x\": 190}, \"upper_lip_1\": {\"y\": 311, \"x\": 192}, \"upper_lip_2\": {\"y\": 311, \"x\": 194}, \"upper_lip_3\": {\"y\": 310, \"x\": 197}, \"upper_lip_4\": {\"y\": 310, \"x\": 199}, \"upper_lip_5\": {\"y\": 309, \"x\": 201}, \"upper_lip_6\": {\"y\": 308, \"x\": 203}, \"upper_lip_7\": {\"y\": 308, \"x\": 205}, \"upper_lip_8\": {\"y\": 307, \"x\": 208}, \"upper_lip_9\": {\"y\": 307, \"x\": 210}, \"lower_lip_3\": {\"y\": 321, \"x\": 196}, \"lower_lip_2\": {\"y\": 319, \"x\": 195}, \"lower_lip_1\": {\"y\": 317, \"x\": 193}, \"lower_lip_0\": {\"y\": 314, \"x\": 191}, \"lower_lip_7\": {\"y\": 328, \"x\": 204}, \"lower_lip_6\": {\"y\": 326, \"x\": 202}, \"lower_lip_5\": {\"y\": 324, \"x\": 200}, \"lower_lip_4\": {\"y\": 323, \"x\": 198}, \"lower_lip_9\": {\"y\": 331, \"x\": 209}, \"lower_lip_8\": {\"y\": 329, \"x\": 207}, \"lower_lip_59\": {\"y\": 314, \"x\": 198}, \"lower_lip_58\": {\"y\": 315, \"x\": 200}, \"lower_lip_53\": {\"y\": 317, \"x\": 211}, \"lower_lip_52\": {\"y\": 317, \"x\": 213}, \"lower_lip_51\": {\"y\": 318, \"x\": 216}, \"lower_lip_50\": {\"y\": 318, \"x\": 218}, \"lower_lip_57\": {\"y\": 315, \"x\": 202}, \"lower_lip_56\": {\"y\": 315, \"x\": 204}, \"lower_lip_55\": {\"y\": 316, \"x\": 207}, \"lower_lip_54\": {\"y\": 316, \"x\": 209}, \"upper_lip_63\": {\"y\": 313, \"x\": 193}, \"upper_lip_62\": {\"y\": 314, \"x\": 195}, \"upper_lip_61\": {\"y\": 314, \"x\": 198}, \"upper_lip_60\": {\"y\": 314, \"x\": 200}, \"lower_lip_62\": {\"y\": 313, \"x\": 191}, \"lower_lip_63\": {\"y\": 313, \"x\": 191}, \"lower_lip_60\": {\"y\": 314, \"x\": 196}, \"lower_lip_61\": {\"y\": 313, \"x\": 193}, \"upper_lip_56\": {\"y\": 316, \"x\": 209}, \"upper_lip_57\": {\"y\": 316, \"x\": 207}, \"upper_lip_54\": {\"y\": 317, \"x\": 213}, \"upper_lip_55\": {\"y\": 316, \"x\": 211}, \"upper_lip_52\": {\"y\": 318, \"x\": 218}, \"upper_lip_53\": {\"y\": 318, \"x\": 216}, \"upper_lip_50\": {\"y\": 320, \"x\": 222}, \"upper_lip_51\": {\"y\": 319, \"x\": 220}, \"upper_lip_58\": {\"y\": 315, \"x\": 204}, \"upper_lip_59\": {\"y\": 315, \"x\": 202}, \"upper_lip_34\": {\"y\": 315, \"x\": 258}, \"upper_lip_35\": {\"y\": 315, \"x\": 256}, \"upper_lip_36\": {\"y\": 315, \"x\": 254}, \"upper_lip_37\": {\"y\": 316, \"x\": 251}, \"upper_lip_30\": {\"y\": 312, \"x\": 257}, \"upper_lip_31\": {\"y\": 313, \"x\": 259}, \"upper_lip_32\": {\"y\": 314, \"x\": 261}, \"upper_lip_33\": {\"y\": 314, \"x\": 260}, \"upper_lip_38\": {\"y\": 316, \"x\": 249}, \"upper_lip_39\": {\"y\": 316, \"x\": 247}, \"upper_lip_41\": {\"y\": 317, \"x\": 242}, \"upper_lip_40\": {\"y\": 317, \"x\": 245}, \"upper_lip_43\": {\"y\": 318, \"x\": 238}, \"upper_lip_42\": {\"y\": 317, \"x\": 240}, \"upper_lip_45\": {\"y\": 319, \"x\": 233}, \"upper_lip_44\": {\"y\": 318, \"x\": 236}, \"upper_lip_47\": {\"y\": 320, \"x\": 229}, \"upper_lip_46\": {\"y\": 319, \"x\": 231}, \"upper_lip_49\": {\"y\": 320, \"x\": 224}, \"upper_lip_48\": {\"y\": 320, \"x\": 227}, \"upper_lip_27\": {\"y\": 311, \"x\": 250}, \"upper_lip_26\": {\"y\": 310, \"x\": 248}, \"upper_lip_25\": {\"y\": 309, \"x\": 246}, \"upper_lip_24\": {\"y\": 309, \"x\": 244}, \"upper_lip_23\": {\"y\": 308, \"x\": 241}, \"upper_lip_22\": {\"y\": 308, \"x\": 239}, \"upper_lip_21\": {\"y\": 308, \"x\": 237}, \"upper_lip_20\": {\"y\": 308, \"x\": 235}, \"upper_lip_29\": {\"y\": 312, \"x\": 255}, \"upper_lip_28\": {\"y\": 311, \"x\": 252}, \"upper_lip_12\": {\"y\": 307, \"x\": 217}, \"upper_lip_13\": {\"y\": 308, \"x\": 219}, \"upper_lip_10\": {\"y\": 307, \"x\": 212}, \"upper_lip_11\": {\"y\": 307, \"x\": 215}, \"upper_lip_16\": {\"y\": 310, \"x\": 226}, \"upper_lip_17\": {\"y\": 310, \"x\": 228}, \"upper_lip_14\": {\"y\": 309, \"x\": 221}, \"upper_lip_15\": {\"y\": 310, \"x\": 223}, \"upper_lip_18\": {\"y\": 309, \"x\": 230}, \"upper_lip_19\": {\"y\": 308, \"x\": 232}, \"lower_lip_17\": {\"y\": 334, \"x\": 231}, \"lower_lip_16\": {\"y\": 334, \"x\": 228}, \"lower_lip_15\": {\"y\": 334, \"x\": 225}, \"lower_lip_14\": {\"y\": 334, \"x\": 222}, \"lower_lip_13\": {\"y\": 334, \"x\": 220}, \"lower_lip_12\": {\"y\": 333, \"x\": 217}, \"lower_lip_11\": {\"y\": 333, \"x\": 214}, \"lower_lip_10\": {\"y\": 332, \"x\": 212}, \"lower_lip_19\": {\"y\": 333, \"x\": 236}, \"lower_lip_18\": {\"y\": 334, \"x\": 233}, \"lower_lip_22\": {\"y\": 330, \"x\": 244}, \"lower_lip_23\": {\"y\": 328, \"x\": 246}, \"lower_lip_20\": {\"y\": 332, \"x\": 239}, \"lower_lip_21\": {\"y\": 331, \"x\": 241}, \"lower_lip_26\": {\"y\": 323, \"x\": 252}, \"lower_lip_27\": {\"y\": 322, \"x\": 254}, \"lower_lip_24\": {\"y\": 327, \"x\": 248}, \"lower_lip_25\": {\"y\": 325, \"x\": 250}, \"lower_lip_28\": {\"y\": 320, \"x\": 256}, \"lower_lip_29\": {\"y\": 318, \"x\": 258}}}, \"face_rectangle\": {\"width\": 225, \"top\": 161, \"height\": 224, \"left\": 119}}}";
            Poco::JSON::Parser parser;
            const Dynamic::Var &var = parser.parse(stRes);
            if(!var.isEmpty()){
                const JSON::Object::Ptr resObj = var.extract<Poco::JSON::Object::Ptr>();
                const JSON::Object::Ptr landmarkObj = resObj->getObject("face")->getObject("landmark");
                const JSON::Object::Ptr mouth = landmarkObj->getObject("mouth");
                //画出眉毛轮廓
                std::vector<cv::Point> lowerContours;
                std::vector<cv::Point> upperContours;
                //找出眼周leftContours中x坐标最大,最小值;y最大最小值
                int x_min = 0x7FFFFFFF,x_max=0,y_min = 0x7FFFFFFF,y_max=0;
                for(int i=0;i<64;++i){
                    const JSON::Object::Ptr &pPtr = mouth->getObject("upper_lip_" + to_string(i));
                    int x = pPtr->get("x");
                    int y = pPtr->get("y");
                    if(x>x_max){
                        x_max = x;
                    }
                    if(x<x_min){
                        x_min = x;
                    }
                    if(y>y_max){
                        y_max = y;
                    }
                    if(y<y_min){
                        y_min = y;
                    }
//                    circle(mat,cv::Point(x,y),1,cv::Scalar(0,0,255));
                    upperContours.push_back(cv::Point(x,y));
                }
                for(int i=0;i<64;++i){
                    const JSON::Object::Ptr &pPtr = mouth->getObject("lower_lip_" + to_string(i));
                    int x = pPtr->get("x");
                    int y = pPtr->get("y");
                    if(x>x_max){
                        x_max = x;
                    }
                    if(x<x_min){
                        x_min = x;
                    }
                    if(y>y_max){
                        y_max = y;
                    }
                    if(y<y_min){
                        y_min = y;
                    }
//                    circle(mat,cv::Point(x,y),1,cv::Scalar(0,0,255));
                    lowerContours.push_back(cv::Point(x,y));
                }


//                vector<unsigned char> data;
//                ifstream ifs("/Users/edz/CLionProjects/AI_Face/sk2.png",ios::binary);
//                char buf[1024];
//                while(ifs.read(buf, sizeof(buf))){
//                    streamsize gcount = ifs.gcount();
//                    for (int i = 0; i < gcount; ++i){
//                        data.push_back(buf[i]);
//                    }
//                }
//                streamsize gcount = ifs.gcount();
//                if(gcount>0){
//                    for (int i = 0; i < gcount; ++i){
//                        data.push_back(buf[i]);
//                    }
//                }
                cv::Mat& lipsLut = lipsLutMap[mtIndex];

                cout << "lipsLut.rows=" << lipsLut.rows << endl;
                cout << "lipsLut.cols=" << lipsLut.cols << endl;
                cout << "lipsLut.channels=" << lipsLut.channels() << endl;

                int height = mat.rows;
                int width = mat.cols;
                int stride = mat.channels();
                uchar* srcData = mat.data;
                uchar* lipsColorMap = lipsLut.data;
                for(int n = 0; n < height; n++)
                {
                    for(int m = 0; m < width; m++)
                    {
                        if(m>=x_min and m<=x_max and n>=y_min and n<=y_max
                           and (cv::pointPolygonTest(lowerContours,cv::Point(m,n),false)!=-1)
                               or (cv::pointPolygonTest(upperContours,cv::Point(m,n),false)!=-1))
                        {
                            //get alpha for blend
                            int pos = width * n * stride + m * stride;
                            int b = srcData[pos];
                            int g = srcData[pos + 1];
                            int r = srcData[pos + 2];
                            //lips recolored using 512 lut
                            int k  =  (b  >>  2);
                            int nx  =  (int)(r  >>  2)  +  ((k  -  ((k  >>  3)  <<  3))  <<  6);
                            int ny  =  (int)(((b  >>  5)  <<  6)  +  (g  >>  2));
                            int mpos  =  (nx * 3)  +  (ny * 512 * 3);
                            int mb = lipsColorMap[mpos];
                            int mg = lipsColorMap[mpos + 1];
                            int mr = lipsColorMap[mpos + 2];
                            //lips and color blend by alpha
                            srcData[pos] = CLIP3(mb, 0, 255);
                            srcData[pos + 1] = CLIP3(mg, 0, 255);
                            srcData[pos + 2] = CLIP3(mr, 0, 255);
                        }
                    }
                }






                cv::cvtColor(mat,mat,cv::COLOR_BGRA2BGR);
//                imshow("美眉",mat);
                imwrite(to_string(mtIndex)+".jpg",mat);
                cout << "time cost:" << stopwatch.elapsed()/1000 << " ms" << endl;
//                imshow("lipsLut",lipsLut);
//                waitKey(0);
            }
        }

    }else{
        return 1;
    }
    return 0;
}
int main(int argc, char* argv[])
{
    map<int,cv::Mat> lipsLutMap;
    //加载lipLUT模板
    string lipsLutBaseDir = "/srv/apps/strategy/app/ai/img/lipsLUT/";
    loadLipLut(lipsLutMap,baseDir);


    //加载lipLUT模板
    string baseDir = "/Users/edz/CLionProjects/AI_Face/lipsLUT/";
    loadLipLut(lipsLutMap,baseDir);

    int mtIndex = stoi(string(argv[1]));

    string photoFilePath = "/Users/edz/CLionProjects/AI_Face/自然唇.png";
//    string photoFilePath = "/Users/edz/Downloads/合集/模特/自然唇.png";

    //计时
    Poco::Stopwatch stopwatch;
    stopwatch.start();
    //获取人脸1000关键点
    URI uri("https://api-cn.faceplusplus.com/facepp/v1/face/thousandlandmark");
    const Poco::Net::Context::Ptr context(
            new Poco::Net::Context(Poco::Net::Context::CLIENT_USE, "", "", "",
                                   Poco::Net::Context::VERIFY_NONE));
    Poco::Net::HTTPSClientSession session(uri.getHost(), uri.getPort(), context);
    HTTPRequest es_request(HTTPRequest::HTTP_POST,uri.getPathAndQuery(),HTTPRequest::HTTP_1_1);
    es_request.setContentType("multipart/form-data");
    HTMLForm form;
    form.setEncoding(HTMLForm::ENCODING_MULTIPART);
    form.add("api_key", "-6zs61jR1M4GqzE9jIO3eiL1W1sojaeE");
    form.add("api_secret", "J82yKgSplMDppw9oPpHeTVTA4hYxp0iB");
    form.add("return_landmark", "mouth");
    //图片base64编码
    //读取图片,获得字节数组和Mat
    vector<unsigned char> data;
    ifstream ifs(photoFilePath,ios::binary);
    if(ifs.is_open()){
        char buf[1024];
        while(ifs.read(buf, sizeof(buf))){
            streamsize gcount = ifs.gcount();
            for (int i = 0; i < gcount; ++i){
                data.push_back(buf[i]);
            }
        }
        streamsize gcount = ifs.gcount();
        if(gcount>0){
            for (int i = 0; i < gcount; ++i){
                data.push_back(buf[i]);
            }
        }
        cv::Mat mat = cv::imdecode(data,CV_LOAD_IMAGE_COLOR);
        unsigned char tmp[data.size()];
        for (int i = 0; i < data.size(); ++i){
            tmp[i] = data.at(i);
        }
        ZBase64 zBase64;
        string base64Str;
        zBase64.Encode(tmp,data.size(),base64Str);
        form.add("image_base64",base64Str);
        form.prepareSubmit(es_request);
        form.write(session.sendRequest(es_request));
        HTTPResponse es_response;
        std::istream &istream = session.receiveResponse(es_response);
        const HTTPResponse::HTTPStatus &status = es_response.getStatus();
        if(HTTPResponse::HTTPStatus::HTTP_OK == status) {
//        if(true) {
            std::string stRes;
            StreamCopier::copyToString(istream, stRes);
            std::cout << stRes << std::endl;
//            string stRes = "{\"time_used\": 155, \"request_id\": \"1618825817,bbcc62bb-db7b-4f65-ac74-8c3c408f27c6\", \"face\": {\"landmark\": {\"right_eyebrow\": {\"right_eyebrow_56\": {\"y\": 363, \"x\": 529}, \"right_eyebrow_57\": {\"y\": 363, \"x\": 532}, \"right_eyebrow_54\": {\"y\": 362, \"x\": 523}, \"right_eyebrow_55\": {\"y\": 362, \"x\": 526}, \"right_eyebrow_38\": {\"y\": 366, \"x\": 477}, \"right_eyebrow_39\": {\"y\": 365, \"x\": 480}, \"right_eyebrow_50\": {\"y\": 362, \"x\": 512}, \"right_eyebrow_51\": {\"y\": 362, \"x\": 514}, \"right_eyebrow_34\": {\"y\": 365, \"x\": 465}, \"right_eyebrow_35\": {\"y\": 366, \"x\": 468}, \"right_eyebrow_36\": {\"y\": 366, \"x\": 471}, \"right_eyebrow_37\": {\"y\": 366, \"x\": 474}, \"right_eyebrow_30\": {\"y\": 355, \"x\": 465}, \"right_eyebrow_31\": {\"y\": 358, \"x\": 464}, \"right_eyebrow_32\": {\"y\": 361, \"x\": 463}, \"right_eyebrow_33\": {\"y\": 364, \"x\": 464}, \"right_eyebrow_12\": {\"y\": 349, \"x\": 520}, \"right_eyebrow_13\": {\"y\": 349, \"x\": 517}, \"right_eyebrow_10\": {\"y\": 350, \"x\": 527}, \"right_eyebrow_11\": {\"y\": 349, \"x\": 524}, \"right_eyebrow_16\": {\"y\": 349, \"x\": 508}, \"right_eyebrow_17\": {\"y\": 349, \"x\": 505}, \"right_eyebrow_14\": {\"y\": 349, \"x\": 514}, \"right_eyebrow_15\": {\"y\": 349, \"x\": 511}, \"right_eyebrow_52\": {\"y\": 362, \"x\": 517}, \"right_eyebrow_18\": {\"y\": 349, \"x\": 502}, \"right_eyebrow_19\": {\"y\": 349, \"x\": 499}, \"right_eyebrow_53\": {\"y\": 362, \"x\": 520}, \"right_eyebrow_44\": {\"y\": 363, \"x\": 494}, \"right_eyebrow_41\": {\"y\": 364, \"x\": 485}, \"right_eyebrow_58\": {\"y\": 363, \"x\": 535}, \"right_eyebrow_40\": {\"y\": 365, \"x\": 482}, \"right_eyebrow_43\": {\"y\": 364, \"x\": 491}, \"right_eyebrow_49\": {\"y\": 362, \"x\": 509}, \"right_eyebrow_48\": {\"y\": 362, \"x\": 506}, \"right_eyebrow_61\": {\"y\": 365, \"x\": 543}, \"right_eyebrow_42\": {\"y\": 364, \"x\": 488}, \"right_eyebrow_29\": {\"y\": 354, \"x\": 468}, \"right_eyebrow_28\": {\"y\": 352, \"x\": 471}, \"right_eyebrow_27\": {\"y\": 352, \"x\": 474}, \"right_eyebrow_26\": {\"y\": 351, \"x\": 477}, \"right_eyebrow_25\": {\"y\": 351, \"x\": 480}, \"right_eyebrow_24\": {\"y\": 350, \"x\": 483}, \"right_eyebrow_23\": {\"y\": 350, \"x\": 486}, \"right_eyebrow_22\": {\"y\": 350, \"x\": 489}, \"right_eyebrow_21\": {\"y\": 350, \"x\": 492}, \"right_eyebrow_20\": {\"y\": 349, \"x\": 495}, \"right_eyebrow_59\": {\"y\": 364, \"x\": 538}, \"right_eyebrow_47\": {\"y\": 363, \"x\": 503}, \"right_eyebrow_60\": {\"y\": 365, \"x\": 541}, \"right_eyebrow_46\": {\"y\": 363, \"x\": 500}, \"right_eyebrow_45\": {\"y\": 363, \"x\": 497}, \"right_eyebrow_8\": {\"y\": 352, \"x\": 533}, \"right_eyebrow_9\": {\"y\": 351, \"x\": 530}, \"right_eyebrow_0\": {\"y\": 366, \"x\": 552}, \"right_eyebrow_1\": {\"y\": 363, \"x\": 551}, \"right_eyebrow_2\": {\"y\": 361, \"x\": 549}, \"right_eyebrow_3\": {\"y\": 359, \"x\": 546}, \"right_eyebrow_4\": {\"y\": 357, \"x\": 544}, \"right_eyebrow_5\": {\"y\": 355, \"x\": 541}, \"right_eyebrow_6\": {\"y\": 354, \"x\": 538}, \"right_eyebrow_7\": {\"y\": 353, \"x\": 536}, \"right_eyebrow_62\": {\"y\": 366, \"x\": 546}, \"right_eyebrow_63\": {\"y\": 367, \"x\": 549}}, \"left_eyebrow\": {\"left_eyebrow_54\": {\"y\": 361, \"x\": 331}, \"left_eyebrow_55\": {\"y\": 361, \"x\": 329}, \"left_eyebrow_52\": {\"y\": 361, \"x\": 337}, \"left_eyebrow_53\": {\"y\": 361, \"x\": 334}, \"left_eyebrow_50\": {\"y\": 361, \"x\": 343}, \"left_eyebrow_51\": {\"y\": 361, \"x\": 340}, \"left_eyebrow_56\": {\"y\": 362, \"x\": 326}, \"left_eyebrow_57\": {\"y\": 362, \"x\": 323}, \"left_eyebrow_18\": {\"y\": 349, \"x\": 352}, \"left_eyebrow_19\": {\"y\": 349, \"x\": 356}, \"left_eyebrow_16\": {\"y\": 349, \"x\": 346}, \"left_eyebrow_17\": {\"y\": 349, \"x\": 349}, \"left_eyebrow_14\": {\"y\": 348, \"x\": 340}, \"left_eyebrow_15\": {\"y\": 348, \"x\": 343}, \"left_eyebrow_12\": {\"y\": 349, \"x\": 334}, \"left_eyebrow_13\": {\"y\": 349, \"x\": 337}, \"left_eyebrow_10\": {\"y\": 349, \"x\": 328}, \"left_eyebrow_11\": {\"y\": 349, \"x\": 331}, \"left_eyebrow_34\": {\"y\": 364, \"x\": 389}, \"left_eyebrow_35\": {\"y\": 365, \"x\": 386}, \"left_eyebrow_36\": {\"y\": 365, \"x\": 383}, \"left_eyebrow_37\": {\"y\": 365, \"x\": 380}, \"left_eyebrow_30\": {\"y\": 354, \"x\": 388}, \"left_eyebrow_31\": {\"y\": 357, \"x\": 390}, \"left_eyebrow_32\": {\"y\": 360, \"x\": 391}, \"left_eyebrow_33\": {\"y\": 363, \"x\": 390}, \"left_eyebrow_38\": {\"y\": 365, \"x\": 378}, \"left_eyebrow_39\": {\"y\": 364, \"x\": 375}, \"left_eyebrow_4\": {\"y\": 355, \"x\": 311}, \"left_eyebrow_5\": {\"y\": 354, \"x\": 313}, \"left_eyebrow_6\": {\"y\": 352, \"x\": 316}, \"left_eyebrow_7\": {\"y\": 351, \"x\": 319}, \"left_eyebrow_0\": {\"y\": 364, \"x\": 303}, \"left_eyebrow_1\": {\"y\": 361, \"x\": 304}, \"left_eyebrow_2\": {\"y\": 359, \"x\": 306}, \"left_eyebrow_3\": {\"y\": 357, \"x\": 308}, \"left_eyebrow_8\": {\"y\": 350, \"x\": 322}, \"left_eyebrow_9\": {\"y\": 350, \"x\": 325}, \"left_eyebrow_45\": {\"y\": 362, \"x\": 358}, \"left_eyebrow_44\": {\"y\": 363, \"x\": 360}, \"left_eyebrow_47\": {\"y\": 362, \"x\": 352}, \"left_eyebrow_46\": {\"y\": 362, \"x\": 355}, \"left_eyebrow_41\": {\"y\": 364, \"x\": 369}, \"left_eyebrow_40\": {\"y\": 364, \"x\": 372}, \"left_eyebrow_43\": {\"y\": 363, \"x\": 363}, \"left_eyebrow_42\": {\"y\": 363, \"x\": 366}, \"left_eyebrow_63\": {\"y\": 364, \"x\": 305}, \"left_eyebrow_62\": {\"y\": 364, \"x\": 308}, \"left_eyebrow_61\": {\"y\": 363, \"x\": 311}, \"left_eyebrow_60\": {\"y\": 363, \"x\": 314}, \"left_eyebrow_49\": {\"y\": 362, \"x\": 346}, \"left_eyebrow_48\": {\"y\": 362, \"x\": 349}, \"left_eyebrow_27\": {\"y\": 351, \"x\": 380}, \"left_eyebrow_26\": {\"y\": 350, \"x\": 377}, \"left_eyebrow_25\": {\"y\": 350, \"x\": 374}, \"left_eyebrow_24\": {\"y\": 350, \"x\": 371}, \"left_eyebrow_23\": {\"y\": 349, \"x\": 368}, \"left_eyebrow_22\": {\"y\": 349, \"x\": 365}, \"left_eyebrow_21\": {\"y\": 349, \"x\": 362}, \"left_eyebrow_20\": {\"y\": 349, \"x\": 359}, \"left_eyebrow_58\": {\"y\": 362, \"x\": 320}, \"left_eyebrow_29\": {\"y\": 353, \"x\": 386}, \"left_eyebrow_28\": {\"y\": 352, \"x\": 383}, \"left_eyebrow_59\": {\"y\": 363, \"x\": 317}}}, \"face_rectangle\": {\"width\": 301, \"top\": 342, \"height\": 300, \"left\": 280}}}";
//            string stRes = "{\"time_used\": 189, \"request_id\": \"1625051282,d64421fc-35f6-4ce8-86ee-aa686e3ff42d\", \"face\": {\"landmark\": {\"mouth\": {\"lower_lip_39\": {\"y\": 317, \"x\": 243}, \"lower_lip_38\": {\"y\": 317, \"x\": 245}, \"lower_lip_35\": {\"y\": 316, \"x\": 251}, \"lower_lip_34\": {\"y\": 315, \"x\": 254}, \"lower_lip_37\": {\"y\": 316, \"x\": 247}, \"lower_lip_36\": {\"y\": 316, \"x\": 249}, \"lower_lip_31\": {\"y\": 314, \"x\": 260}, \"lower_lip_30\": {\"y\": 316, \"x\": 260}, \"lower_lip_33\": {\"y\": 315, \"x\": 256}, \"lower_lip_32\": {\"y\": 315, \"x\": 258}, \"lower_lip_48\": {\"y\": 319, \"x\": 222}, \"lower_lip_49\": {\"y\": 319, \"x\": 220}, \"lower_lip_40\": {\"y\": 317, \"x\": 240}, \"lower_lip_41\": {\"y\": 318, \"x\": 238}, \"lower_lip_42\": {\"y\": 318, \"x\": 236}, \"lower_lip_43\": {\"y\": 319, \"x\": 234}, \"lower_lip_44\": {\"y\": 319, \"x\": 231}, \"lower_lip_45\": {\"y\": 320, \"x\": 229}, \"lower_lip_46\": {\"y\": 320, \"x\": 227}, \"lower_lip_47\": {\"y\": 320, \"x\": 225}, \"upper_lip_0\": {\"y\": 312, \"x\": 190}, \"upper_lip_1\": {\"y\": 311, \"x\": 192}, \"upper_lip_2\": {\"y\": 311, \"x\": 194}, \"upper_lip_3\": {\"y\": 310, \"x\": 197}, \"upper_lip_4\": {\"y\": 310, \"x\": 199}, \"upper_lip_5\": {\"y\": 309, \"x\": 201}, \"upper_lip_6\": {\"y\": 308, \"x\": 203}, \"upper_lip_7\": {\"y\": 308, \"x\": 205}, \"upper_lip_8\": {\"y\": 307, \"x\": 208}, \"upper_lip_9\": {\"y\": 307, \"x\": 210}, \"lower_lip_3\": {\"y\": 321, \"x\": 196}, \"lower_lip_2\": {\"y\": 319, \"x\": 195}, \"lower_lip_1\": {\"y\": 317, \"x\": 193}, \"lower_lip_0\": {\"y\": 314, \"x\": 191}, \"lower_lip_7\": {\"y\": 328, \"x\": 204}, \"lower_lip_6\": {\"y\": 326, \"x\": 202}, \"lower_lip_5\": {\"y\": 324, \"x\": 200}, \"lower_lip_4\": {\"y\": 323, \"x\": 198}, \"lower_lip_9\": {\"y\": 331, \"x\": 209}, \"lower_lip_8\": {\"y\": 329, \"x\": 207}, \"lower_lip_59\": {\"y\": 314, \"x\": 198}, \"lower_lip_58\": {\"y\": 315, \"x\": 200}, \"lower_lip_53\": {\"y\": 317, \"x\": 211}, \"lower_lip_52\": {\"y\": 317, \"x\": 213}, \"lower_lip_51\": {\"y\": 318, \"x\": 216}, \"lower_lip_50\": {\"y\": 318, \"x\": 218}, \"lower_lip_57\": {\"y\": 315, \"x\": 202}, \"lower_lip_56\": {\"y\": 315, \"x\": 204}, \"lower_lip_55\": {\"y\": 316, \"x\": 207}, \"lower_lip_54\": {\"y\": 316, \"x\": 209}, \"upper_lip_63\": {\"y\": 313, \"x\": 193}, \"upper_lip_62\": {\"y\": 314, \"x\": 195}, \"upper_lip_61\": {\"y\": 314, \"x\": 198}, \"upper_lip_60\": {\"y\": 314, \"x\": 200}, \"lower_lip_62\": {\"y\": 313, \"x\": 191}, \"lower_lip_63\": {\"y\": 313, \"x\": 191}, \"lower_lip_60\": {\"y\": 314, \"x\": 196}, \"lower_lip_61\": {\"y\": 313, \"x\": 193}, \"upper_lip_56\": {\"y\": 316, \"x\": 209}, \"upper_lip_57\": {\"y\": 316, \"x\": 207}, \"upper_lip_54\": {\"y\": 317, \"x\": 213}, \"upper_lip_55\": {\"y\": 316, \"x\": 211}, \"upper_lip_52\": {\"y\": 318, \"x\": 218}, \"upper_lip_53\": {\"y\": 318, \"x\": 216}, \"upper_lip_50\": {\"y\": 320, \"x\": 222}, \"upper_lip_51\": {\"y\": 319, \"x\": 220}, \"upper_lip_58\": {\"y\": 315, \"x\": 204}, \"upper_lip_59\": {\"y\": 315, \"x\": 202}, \"upper_lip_34\": {\"y\": 315, \"x\": 258}, \"upper_lip_35\": {\"y\": 315, \"x\": 256}, \"upper_lip_36\": {\"y\": 315, \"x\": 254}, \"upper_lip_37\": {\"y\": 316, \"x\": 251}, \"upper_lip_30\": {\"y\": 312, \"x\": 257}, \"upper_lip_31\": {\"y\": 313, \"x\": 259}, \"upper_lip_32\": {\"y\": 314, \"x\": 261}, \"upper_lip_33\": {\"y\": 314, \"x\": 260}, \"upper_lip_38\": {\"y\": 316, \"x\": 249}, \"upper_lip_39\": {\"y\": 316, \"x\": 247}, \"upper_lip_41\": {\"y\": 317, \"x\": 242}, \"upper_lip_40\": {\"y\": 317, \"x\": 245}, \"upper_lip_43\": {\"y\": 318, \"x\": 238}, \"upper_lip_42\": {\"y\": 317, \"x\": 240}, \"upper_lip_45\": {\"y\": 319, \"x\": 233}, \"upper_lip_44\": {\"y\": 318, \"x\": 236}, \"upper_lip_47\": {\"y\": 320, \"x\": 229}, \"upper_lip_46\": {\"y\": 319, \"x\": 231}, \"upper_lip_49\": {\"y\": 320, \"x\": 224}, \"upper_lip_48\": {\"y\": 320, \"x\": 227}, \"upper_lip_27\": {\"y\": 311, \"x\": 250}, \"upper_lip_26\": {\"y\": 310, \"x\": 248}, \"upper_lip_25\": {\"y\": 309, \"x\": 246}, \"upper_lip_24\": {\"y\": 309, \"x\": 244}, \"upper_lip_23\": {\"y\": 308, \"x\": 241}, \"upper_lip_22\": {\"y\": 308, \"x\": 239}, \"upper_lip_21\": {\"y\": 308, \"x\": 237}, \"upper_lip_20\": {\"y\": 308, \"x\": 235}, \"upper_lip_29\": {\"y\": 312, \"x\": 255}, \"upper_lip_28\": {\"y\": 311, \"x\": 252}, \"upper_lip_12\": {\"y\": 307, \"x\": 217}, \"upper_lip_13\": {\"y\": 308, \"x\": 219}, \"upper_lip_10\": {\"y\": 307, \"x\": 212}, \"upper_lip_11\": {\"y\": 307, \"x\": 215}, \"upper_lip_16\": {\"y\": 310, \"x\": 226}, \"upper_lip_17\": {\"y\": 310, \"x\": 228}, \"upper_lip_14\": {\"y\": 309, \"x\": 221}, \"upper_lip_15\": {\"y\": 310, \"x\": 223}, \"upper_lip_18\": {\"y\": 309, \"x\": 230}, \"upper_lip_19\": {\"y\": 308, \"x\": 232}, \"lower_lip_17\": {\"y\": 334, \"x\": 231}, \"lower_lip_16\": {\"y\": 334, \"x\": 228}, \"lower_lip_15\": {\"y\": 334, \"x\": 225}, \"lower_lip_14\": {\"y\": 334, \"x\": 222}, \"lower_lip_13\": {\"y\": 334, \"x\": 220}, \"lower_lip_12\": {\"y\": 333, \"x\": 217}, \"lower_lip_11\": {\"y\": 333, \"x\": 214}, \"lower_lip_10\": {\"y\": 332, \"x\": 212}, \"lower_lip_19\": {\"y\": 333, \"x\": 236}, \"lower_lip_18\": {\"y\": 334, \"x\": 233}, \"lower_lip_22\": {\"y\": 330, \"x\": 244}, \"lower_lip_23\": {\"y\": 328, \"x\": 246}, \"lower_lip_20\": {\"y\": 332, \"x\": 239}, \"lower_lip_21\": {\"y\": 331, \"x\": 241}, \"lower_lip_26\": {\"y\": 323, \"x\": 252}, \"lower_lip_27\": {\"y\": 322, \"x\": 254}, \"lower_lip_24\": {\"y\": 327, \"x\": 248}, \"lower_lip_25\": {\"y\": 325, \"x\": 250}, \"lower_lip_28\": {\"y\": 320, \"x\": 256}, \"lower_lip_29\": {\"y\": 318, \"x\": 258}}}, \"face_rectangle\": {\"width\": 225, \"top\": 161, \"height\": 224, \"left\": 119}}}";
            Poco::JSON::Parser parser;
            const Dynamic::Var &var = parser.parse(stRes);
            if(!var.isEmpty()){
                const JSON::Object::Ptr resObj = var.extract<Poco::JSON::Object::Ptr>();
                const JSON::Object::Ptr landmarkObj = resObj->getObject("face")->getObject("landmark");
                const JSON::Object::Ptr mouth = landmarkObj->getObject("mouth");
                //画出眉毛轮廓
                std::vector<cv::Point> lowerContours;
                std::vector<cv::Point> upperContours;
                //找出眼周leftContours中x坐标最大,最小值;y最大最小值
                int x_min = 0x7FFFFFFF,x_max=0,y_min = 0x7FFFFFFF,y_max=0;
                for(int i=0;i<64;++i){
                    const JSON::Object::Ptr &pPtr = mouth->getObject("upper_lip_" + to_string(i));
                    int x = pPtr->get("x");
                    int y = pPtr->get("y");
                    if(x>x_max){
                        x_max = x;
                    }
                    if(x<x_min){
                        x_min = x;
                    }
                    if(y>y_max){
                        y_max = y;
                    }
                    if(y<y_min){
                        y_min = y;
                    }
//                    circle(mat,cv::Point(x,y),1,cv::Scalar(0,0,255));
                    upperContours.push_back(cv::Point(x,y));
                }
                for(int i=0;i<64;++i){
                    const JSON::Object::Ptr &pPtr = mouth->getObject("lower_lip_" + to_string(i));
                    int x = pPtr->get("x");
                    int y = pPtr->get("y");
                    if(x>x_max){
                        x_max = x;
                    }
                    if(x<x_min){
                        x_min = x;
                    }
                    if(y>y_max){
                        y_max = y;
                    }
                    if(y<y_min){
                        y_min = y;
                    }
//                    circle(mat,cv::Point(x,y),1,cv::Scalar(0,0,255));
                    lowerContours.push_back(cv::Point(x,y));
                }


//                vector<unsigned char> data;
//                ifstream ifs("/Users/edz/CLionProjects/AI_Face/sk2.png",ios::binary);
//                char buf[1024];
//                while(ifs.read(buf, sizeof(buf))){
//                    streamsize gcount = ifs.gcount();
//                    for (int i = 0; i < gcount; ++i){
//                        data.push_back(buf[i]);
//                    }
//                }
//                streamsize gcount = ifs.gcount();
//                if(gcount>0){
//                    for (int i = 0; i < gcount; ++i){
//                        data.push_back(buf[i]);
//                    }
//                }
                cv::Mat& lipsLut = lipsLutMap[mtIndex];

                cout << "lipsLut.rows=" << lipsLut.rows << endl;
                cout << "lipsLut.cols=" << lipsLut.cols << endl;
                cout << "lipsLut.channels=" << lipsLut.channels() << endl;

                int height = mat.rows;
                int width = mat.cols;
                int stride = mat.channels();
                uchar* srcData = mat.data;
                uchar* lipsColorMap = lipsLut.data;
                for(int n = 0; n < height; n++)
                {
                    for(int m = 0; m < width; m++)
                    {
                        if(m>=x_min and m<=x_max and n>=y_min and n<=y_max
                           and (cv::pointPolygonTest(lowerContours,cv::Point(m,n),false)!=-1)
                               or (cv::pointPolygonTest(upperContours,cv::Point(m,n),false)!=-1))
                        {
                            //get alpha for blend
                            int pos = width * n * stride + m * stride;
                            int b = srcData[pos];
                            int g = srcData[pos + 1];
                            int r = srcData[pos + 2];
                            //lips recolored using 512 lut
                            int k  =  (b  >>  2);
                            int nx  =  (int)(r  >>  2)  +  ((k  -  ((k  >>  3)  <<  3))  <<  6);
                            int ny  =  (int)(((b  >>  5)  <<  6)  +  (g  >>  2));
                            int mpos  =  (nx * 3)  +  (ny * 512 * 3);
                            int mb = lipsColorMap[mpos];
                            int mg = lipsColorMap[mpos + 1];
                            int mr = lipsColorMap[mpos + 2];
                            //lips and color blend by alpha
                            srcData[pos] = CLIP3(mb, 0, 255);
                            srcData[pos + 1] = CLIP3(mg, 0, 255);
                            srcData[pos + 2] = CLIP3(mr, 0, 255);
                        }
                    }
                }






                cv::cvtColor(mat,mat,cv::COLOR_BGRA2BGR);
//                imshow("美眉",mat);
                imwrite(to_string(mtIndex)+".jpg",mat);
                cout << "time cost:" << stopwatch.elapsed()/1000 << " ms" << endl;
//                imshow("lipsLut",lipsLut);
//                waitKey(0);
            }
        }

    }else{
        return 1;
    }
    return 0;
}


int main1()
{
    map<int,cv::Mat> lipsLutMap;

    //加载lipLUT模板
    string baseDir = "/Users/edz/CLionProjects/AI_Face/lipsLUT/";
    DIR* dir = opendir(baseDir.c_str());//打开指定目录
    dirent* p = NULL;//定义遍历指针
    while((p = readdir(dir)) != NULL)//开始逐个遍历
    {
        //这里需要注意，linux平台下一个目录中有"."和".."隐藏文件，需要过滤掉
        if(p->d_name[0] != '.')//d_name是一个char数组，存放当前遍历到的文件名
        {
            string name = string(p->d_name);
            cout<<name<<endl;
            Poco::StringTokenizer stringTokenizer(name,".");
            cout << stringTokenizer[0] << endl;
            lipsLutMap[stoi(stringTokenizer[0])] = cv::imread(baseDir+name);
        }
    }
    closedir(dir);//关闭指定目录


    int mtIndex = 1;

    string photoFilePath = "/Users/edz/CLionProjects/AI_Face/5-11-0.png";

    //计时
    Poco::Stopwatch stopwatch;
    stopwatch.start();
    //获取人脸1000关键点
    URI uri("https://api-cn.faceplusplus.com/facepp/v1/face/thousandlandmark");
    const Poco::Net::Context::Ptr context(
            new Poco::Net::Context(Poco::Net::Context::CLIENT_USE, "", "", "",
                                   Poco::Net::Context::VERIFY_NONE));
    Poco::Net::HTTPSClientSession session(uri.getHost(), uri.getPort(), context);
    HTTPRequest es_request(HTTPRequest::HTTP_POST,uri.getPathAndQuery(),HTTPRequest::HTTP_1_1);
    es_request.setContentType("multipart/form-data");
    HTMLForm form;
    form.setEncoding(HTMLForm::ENCODING_MULTIPART);
    form.add("api_key", "-6zs61jR1M4GqzE9jIO3eiL1W1sojaeE");
    form.add("api_secret", "J82yKgSplMDppw9oPpHeTVTA4hYxp0iB");
    form.add("return_landmark", "mouth");
    //图片base64编码
    //读取图片,获得字节数组和Mat
    vector<unsigned char> data;
    ifstream ifs(photoFilePath,ios::binary);
    if(ifs.is_open()){
        char buf[1024];
        while(ifs.read(buf, sizeof(buf))){
            streamsize gcount = ifs.gcount();
            for (int i = 0; i < gcount; ++i){
                data.push_back(buf[i]);
            }
        }
        streamsize gcount = ifs.gcount();
        if(gcount>0){
            for (int i = 0; i < gcount; ++i){
                data.push_back(buf[i]);
            }
        }
        cv::Mat mat = cv::imdecode(data,CV_LOAD_IMAGE_COLOR);
        unsigned char tmp[data.size()];
        for (int i = 0; i < data.size(); ++i){
            tmp[i] = data.at(i);
        }
        ZBase64 zBase64;
        string base64Str;
        zBase64.Encode(tmp,data.size(),base64Str);
        form.add("image_base64",base64Str);
        form.prepareSubmit(es_request);
        form.write(session.sendRequest(es_request));
        HTTPResponse es_response;
        std::istream &istream = session.receiveResponse(es_response);
        const HTTPResponse::HTTPStatus &status = es_response.getStatus();
        if(HTTPResponse::HTTPStatus::HTTP_OK == status) {
//        if(true) {
            std::string stRes;
            StreamCopier::copyToString(istream, stRes);
            std::cout << stRes << std::endl;
//            string stRes = "{\"time_used\": 155, \"request_id\": \"1618825817,bbcc62bb-db7b-4f65-ac74-8c3c408f27c6\", \"face\": {\"landmark\": {\"right_eyebrow\": {\"right_eyebrow_56\": {\"y\": 363, \"x\": 529}, \"right_eyebrow_57\": {\"y\": 363, \"x\": 532}, \"right_eyebrow_54\": {\"y\": 362, \"x\": 523}, \"right_eyebrow_55\": {\"y\": 362, \"x\": 526}, \"right_eyebrow_38\": {\"y\": 366, \"x\": 477}, \"right_eyebrow_39\": {\"y\": 365, \"x\": 480}, \"right_eyebrow_50\": {\"y\": 362, \"x\": 512}, \"right_eyebrow_51\": {\"y\": 362, \"x\": 514}, \"right_eyebrow_34\": {\"y\": 365, \"x\": 465}, \"right_eyebrow_35\": {\"y\": 366, \"x\": 468}, \"right_eyebrow_36\": {\"y\": 366, \"x\": 471}, \"right_eyebrow_37\": {\"y\": 366, \"x\": 474}, \"right_eyebrow_30\": {\"y\": 355, \"x\": 465}, \"right_eyebrow_31\": {\"y\": 358, \"x\": 464}, \"right_eyebrow_32\": {\"y\": 361, \"x\": 463}, \"right_eyebrow_33\": {\"y\": 364, \"x\": 464}, \"right_eyebrow_12\": {\"y\": 349, \"x\": 520}, \"right_eyebrow_13\": {\"y\": 349, \"x\": 517}, \"right_eyebrow_10\": {\"y\": 350, \"x\": 527}, \"right_eyebrow_11\": {\"y\": 349, \"x\": 524}, \"right_eyebrow_16\": {\"y\": 349, \"x\": 508}, \"right_eyebrow_17\": {\"y\": 349, \"x\": 505}, \"right_eyebrow_14\": {\"y\": 349, \"x\": 514}, \"right_eyebrow_15\": {\"y\": 349, \"x\": 511}, \"right_eyebrow_52\": {\"y\": 362, \"x\": 517}, \"right_eyebrow_18\": {\"y\": 349, \"x\": 502}, \"right_eyebrow_19\": {\"y\": 349, \"x\": 499}, \"right_eyebrow_53\": {\"y\": 362, \"x\": 520}, \"right_eyebrow_44\": {\"y\": 363, \"x\": 494}, \"right_eyebrow_41\": {\"y\": 364, \"x\": 485}, \"right_eyebrow_58\": {\"y\": 363, \"x\": 535}, \"right_eyebrow_40\": {\"y\": 365, \"x\": 482}, \"right_eyebrow_43\": {\"y\": 364, \"x\": 491}, \"right_eyebrow_49\": {\"y\": 362, \"x\": 509}, \"right_eyebrow_48\": {\"y\": 362, \"x\": 506}, \"right_eyebrow_61\": {\"y\": 365, \"x\": 543}, \"right_eyebrow_42\": {\"y\": 364, \"x\": 488}, \"right_eyebrow_29\": {\"y\": 354, \"x\": 468}, \"right_eyebrow_28\": {\"y\": 352, \"x\": 471}, \"right_eyebrow_27\": {\"y\": 352, \"x\": 474}, \"right_eyebrow_26\": {\"y\": 351, \"x\": 477}, \"right_eyebrow_25\": {\"y\": 351, \"x\": 480}, \"right_eyebrow_24\": {\"y\": 350, \"x\": 483}, \"right_eyebrow_23\": {\"y\": 350, \"x\": 486}, \"right_eyebrow_22\": {\"y\": 350, \"x\": 489}, \"right_eyebrow_21\": {\"y\": 350, \"x\": 492}, \"right_eyebrow_20\": {\"y\": 349, \"x\": 495}, \"right_eyebrow_59\": {\"y\": 364, \"x\": 538}, \"right_eyebrow_47\": {\"y\": 363, \"x\": 503}, \"right_eyebrow_60\": {\"y\": 365, \"x\": 541}, \"right_eyebrow_46\": {\"y\": 363, \"x\": 500}, \"right_eyebrow_45\": {\"y\": 363, \"x\": 497}, \"right_eyebrow_8\": {\"y\": 352, \"x\": 533}, \"right_eyebrow_9\": {\"y\": 351, \"x\": 530}, \"right_eyebrow_0\": {\"y\": 366, \"x\": 552}, \"right_eyebrow_1\": {\"y\": 363, \"x\": 551}, \"right_eyebrow_2\": {\"y\": 361, \"x\": 549}, \"right_eyebrow_3\": {\"y\": 359, \"x\": 546}, \"right_eyebrow_4\": {\"y\": 357, \"x\": 544}, \"right_eyebrow_5\": {\"y\": 355, \"x\": 541}, \"right_eyebrow_6\": {\"y\": 354, \"x\": 538}, \"right_eyebrow_7\": {\"y\": 353, \"x\": 536}, \"right_eyebrow_62\": {\"y\": 366, \"x\": 546}, \"right_eyebrow_63\": {\"y\": 367, \"x\": 549}}, \"left_eyebrow\": {\"left_eyebrow_54\": {\"y\": 361, \"x\": 331}, \"left_eyebrow_55\": {\"y\": 361, \"x\": 329}, \"left_eyebrow_52\": {\"y\": 361, \"x\": 337}, \"left_eyebrow_53\": {\"y\": 361, \"x\": 334}, \"left_eyebrow_50\": {\"y\": 361, \"x\": 343}, \"left_eyebrow_51\": {\"y\": 361, \"x\": 340}, \"left_eyebrow_56\": {\"y\": 362, \"x\": 326}, \"left_eyebrow_57\": {\"y\": 362, \"x\": 323}, \"left_eyebrow_18\": {\"y\": 349, \"x\": 352}, \"left_eyebrow_19\": {\"y\": 349, \"x\": 356}, \"left_eyebrow_16\": {\"y\": 349, \"x\": 346}, \"left_eyebrow_17\": {\"y\": 349, \"x\": 349}, \"left_eyebrow_14\": {\"y\": 348, \"x\": 340}, \"left_eyebrow_15\": {\"y\": 348, \"x\": 343}, \"left_eyebrow_12\": {\"y\": 349, \"x\": 334}, \"left_eyebrow_13\": {\"y\": 349, \"x\": 337}, \"left_eyebrow_10\": {\"y\": 349, \"x\": 328}, \"left_eyebrow_11\": {\"y\": 349, \"x\": 331}, \"left_eyebrow_34\": {\"y\": 364, \"x\": 389}, \"left_eyebrow_35\": {\"y\": 365, \"x\": 386}, \"left_eyebrow_36\": {\"y\": 365, \"x\": 383}, \"left_eyebrow_37\": {\"y\": 365, \"x\": 380}, \"left_eyebrow_30\": {\"y\": 354, \"x\": 388}, \"left_eyebrow_31\": {\"y\": 357, \"x\": 390}, \"left_eyebrow_32\": {\"y\": 360, \"x\": 391}, \"left_eyebrow_33\": {\"y\": 363, \"x\": 390}, \"left_eyebrow_38\": {\"y\": 365, \"x\": 378}, \"left_eyebrow_39\": {\"y\": 364, \"x\": 375}, \"left_eyebrow_4\": {\"y\": 355, \"x\": 311}, \"left_eyebrow_5\": {\"y\": 354, \"x\": 313}, \"left_eyebrow_6\": {\"y\": 352, \"x\": 316}, \"left_eyebrow_7\": {\"y\": 351, \"x\": 319}, \"left_eyebrow_0\": {\"y\": 364, \"x\": 303}, \"left_eyebrow_1\": {\"y\": 361, \"x\": 304}, \"left_eyebrow_2\": {\"y\": 359, \"x\": 306}, \"left_eyebrow_3\": {\"y\": 357, \"x\": 308}, \"left_eyebrow_8\": {\"y\": 350, \"x\": 322}, \"left_eyebrow_9\": {\"y\": 350, \"x\": 325}, \"left_eyebrow_45\": {\"y\": 362, \"x\": 358}, \"left_eyebrow_44\": {\"y\": 363, \"x\": 360}, \"left_eyebrow_47\": {\"y\": 362, \"x\": 352}, \"left_eyebrow_46\": {\"y\": 362, \"x\": 355}, \"left_eyebrow_41\": {\"y\": 364, \"x\": 369}, \"left_eyebrow_40\": {\"y\": 364, \"x\": 372}, \"left_eyebrow_43\": {\"y\": 363, \"x\": 363}, \"left_eyebrow_42\": {\"y\": 363, \"x\": 366}, \"left_eyebrow_63\": {\"y\": 364, \"x\": 305}, \"left_eyebrow_62\": {\"y\": 364, \"x\": 308}, \"left_eyebrow_61\": {\"y\": 363, \"x\": 311}, \"left_eyebrow_60\": {\"y\": 363, \"x\": 314}, \"left_eyebrow_49\": {\"y\": 362, \"x\": 346}, \"left_eyebrow_48\": {\"y\": 362, \"x\": 349}, \"left_eyebrow_27\": {\"y\": 351, \"x\": 380}, \"left_eyebrow_26\": {\"y\": 350, \"x\": 377}, \"left_eyebrow_25\": {\"y\": 350, \"x\": 374}, \"left_eyebrow_24\": {\"y\": 350, \"x\": 371}, \"left_eyebrow_23\": {\"y\": 349, \"x\": 368}, \"left_eyebrow_22\": {\"y\": 349, \"x\": 365}, \"left_eyebrow_21\": {\"y\": 349, \"x\": 362}, \"left_eyebrow_20\": {\"y\": 349, \"x\": 359}, \"left_eyebrow_58\": {\"y\": 362, \"x\": 320}, \"left_eyebrow_29\": {\"y\": 353, \"x\": 386}, \"left_eyebrow_28\": {\"y\": 352, \"x\": 383}, \"left_eyebrow_59\": {\"y\": 363, \"x\": 317}}}, \"face_rectangle\": {\"width\": 301, \"top\": 342, \"height\": 300, \"left\": 280}}}";
//            string stRes = "{\"time_used\": 189, \"request_id\": \"1625051282,d64421fc-35f6-4ce8-86ee-aa686e3ff42d\", \"face\": {\"landmark\": {\"mouth\": {\"lower_lip_39\": {\"y\": 317, \"x\": 243}, \"lower_lip_38\": {\"y\": 317, \"x\": 245}, \"lower_lip_35\": {\"y\": 316, \"x\": 251}, \"lower_lip_34\": {\"y\": 315, \"x\": 254}, \"lower_lip_37\": {\"y\": 316, \"x\": 247}, \"lower_lip_36\": {\"y\": 316, \"x\": 249}, \"lower_lip_31\": {\"y\": 314, \"x\": 260}, \"lower_lip_30\": {\"y\": 316, \"x\": 260}, \"lower_lip_33\": {\"y\": 315, \"x\": 256}, \"lower_lip_32\": {\"y\": 315, \"x\": 258}, \"lower_lip_48\": {\"y\": 319, \"x\": 222}, \"lower_lip_49\": {\"y\": 319, \"x\": 220}, \"lower_lip_40\": {\"y\": 317, \"x\": 240}, \"lower_lip_41\": {\"y\": 318, \"x\": 238}, \"lower_lip_42\": {\"y\": 318, \"x\": 236}, \"lower_lip_43\": {\"y\": 319, \"x\": 234}, \"lower_lip_44\": {\"y\": 319, \"x\": 231}, \"lower_lip_45\": {\"y\": 320, \"x\": 229}, \"lower_lip_46\": {\"y\": 320, \"x\": 227}, \"lower_lip_47\": {\"y\": 320, \"x\": 225}, \"upper_lip_0\": {\"y\": 312, \"x\": 190}, \"upper_lip_1\": {\"y\": 311, \"x\": 192}, \"upper_lip_2\": {\"y\": 311, \"x\": 194}, \"upper_lip_3\": {\"y\": 310, \"x\": 197}, \"upper_lip_4\": {\"y\": 310, \"x\": 199}, \"upper_lip_5\": {\"y\": 309, \"x\": 201}, \"upper_lip_6\": {\"y\": 308, \"x\": 203}, \"upper_lip_7\": {\"y\": 308, \"x\": 205}, \"upper_lip_8\": {\"y\": 307, \"x\": 208}, \"upper_lip_9\": {\"y\": 307, \"x\": 210}, \"lower_lip_3\": {\"y\": 321, \"x\": 196}, \"lower_lip_2\": {\"y\": 319, \"x\": 195}, \"lower_lip_1\": {\"y\": 317, \"x\": 193}, \"lower_lip_0\": {\"y\": 314, \"x\": 191}, \"lower_lip_7\": {\"y\": 328, \"x\": 204}, \"lower_lip_6\": {\"y\": 326, \"x\": 202}, \"lower_lip_5\": {\"y\": 324, \"x\": 200}, \"lower_lip_4\": {\"y\": 323, \"x\": 198}, \"lower_lip_9\": {\"y\": 331, \"x\": 209}, \"lower_lip_8\": {\"y\": 329, \"x\": 207}, \"lower_lip_59\": {\"y\": 314, \"x\": 198}, \"lower_lip_58\": {\"y\": 315, \"x\": 200}, \"lower_lip_53\": {\"y\": 317, \"x\": 211}, \"lower_lip_52\": {\"y\": 317, \"x\": 213}, \"lower_lip_51\": {\"y\": 318, \"x\": 216}, \"lower_lip_50\": {\"y\": 318, \"x\": 218}, \"lower_lip_57\": {\"y\": 315, \"x\": 202}, \"lower_lip_56\": {\"y\": 315, \"x\": 204}, \"lower_lip_55\": {\"y\": 316, \"x\": 207}, \"lower_lip_54\": {\"y\": 316, \"x\": 209}, \"upper_lip_63\": {\"y\": 313, \"x\": 193}, \"upper_lip_62\": {\"y\": 314, \"x\": 195}, \"upper_lip_61\": {\"y\": 314, \"x\": 198}, \"upper_lip_60\": {\"y\": 314, \"x\": 200}, \"lower_lip_62\": {\"y\": 313, \"x\": 191}, \"lower_lip_63\": {\"y\": 313, \"x\": 191}, \"lower_lip_60\": {\"y\": 314, \"x\": 196}, \"lower_lip_61\": {\"y\": 313, \"x\": 193}, \"upper_lip_56\": {\"y\": 316, \"x\": 209}, \"upper_lip_57\": {\"y\": 316, \"x\": 207}, \"upper_lip_54\": {\"y\": 317, \"x\": 213}, \"upper_lip_55\": {\"y\": 316, \"x\": 211}, \"upper_lip_52\": {\"y\": 318, \"x\": 218}, \"upper_lip_53\": {\"y\": 318, \"x\": 216}, \"upper_lip_50\": {\"y\": 320, \"x\": 222}, \"upper_lip_51\": {\"y\": 319, \"x\": 220}, \"upper_lip_58\": {\"y\": 315, \"x\": 204}, \"upper_lip_59\": {\"y\": 315, \"x\": 202}, \"upper_lip_34\": {\"y\": 315, \"x\": 258}, \"upper_lip_35\": {\"y\": 315, \"x\": 256}, \"upper_lip_36\": {\"y\": 315, \"x\": 254}, \"upper_lip_37\": {\"y\": 316, \"x\": 251}, \"upper_lip_30\": {\"y\": 312, \"x\": 257}, \"upper_lip_31\": {\"y\": 313, \"x\": 259}, \"upper_lip_32\": {\"y\": 314, \"x\": 261}, \"upper_lip_33\": {\"y\": 314, \"x\": 260}, \"upper_lip_38\": {\"y\": 316, \"x\": 249}, \"upper_lip_39\": {\"y\": 316, \"x\": 247}, \"upper_lip_41\": {\"y\": 317, \"x\": 242}, \"upper_lip_40\": {\"y\": 317, \"x\": 245}, \"upper_lip_43\": {\"y\": 318, \"x\": 238}, \"upper_lip_42\": {\"y\": 317, \"x\": 240}, \"upper_lip_45\": {\"y\": 319, \"x\": 233}, \"upper_lip_44\": {\"y\": 318, \"x\": 236}, \"upper_lip_47\": {\"y\": 320, \"x\": 229}, \"upper_lip_46\": {\"y\": 319, \"x\": 231}, \"upper_lip_49\": {\"y\": 320, \"x\": 224}, \"upper_lip_48\": {\"y\": 320, \"x\": 227}, \"upper_lip_27\": {\"y\": 311, \"x\": 250}, \"upper_lip_26\": {\"y\": 310, \"x\": 248}, \"upper_lip_25\": {\"y\": 309, \"x\": 246}, \"upper_lip_24\": {\"y\": 309, \"x\": 244}, \"upper_lip_23\": {\"y\": 308, \"x\": 241}, \"upper_lip_22\": {\"y\": 308, \"x\": 239}, \"upper_lip_21\": {\"y\": 308, \"x\": 237}, \"upper_lip_20\": {\"y\": 308, \"x\": 235}, \"upper_lip_29\": {\"y\": 312, \"x\": 255}, \"upper_lip_28\": {\"y\": 311, \"x\": 252}, \"upper_lip_12\": {\"y\": 307, \"x\": 217}, \"upper_lip_13\": {\"y\": 308, \"x\": 219}, \"upper_lip_10\": {\"y\": 307, \"x\": 212}, \"upper_lip_11\": {\"y\": 307, \"x\": 215}, \"upper_lip_16\": {\"y\": 310, \"x\": 226}, \"upper_lip_17\": {\"y\": 310, \"x\": 228}, \"upper_lip_14\": {\"y\": 309, \"x\": 221}, \"upper_lip_15\": {\"y\": 310, \"x\": 223}, \"upper_lip_18\": {\"y\": 309, \"x\": 230}, \"upper_lip_19\": {\"y\": 308, \"x\": 232}, \"lower_lip_17\": {\"y\": 334, \"x\": 231}, \"lower_lip_16\": {\"y\": 334, \"x\": 228}, \"lower_lip_15\": {\"y\": 334, \"x\": 225}, \"lower_lip_14\": {\"y\": 334, \"x\": 222}, \"lower_lip_13\": {\"y\": 334, \"x\": 220}, \"lower_lip_12\": {\"y\": 333, \"x\": 217}, \"lower_lip_11\": {\"y\": 333, \"x\": 214}, \"lower_lip_10\": {\"y\": 332, \"x\": 212}, \"lower_lip_19\": {\"y\": 333, \"x\": 236}, \"lower_lip_18\": {\"y\": 334, \"x\": 233}, \"lower_lip_22\": {\"y\": 330, \"x\": 244}, \"lower_lip_23\": {\"y\": 328, \"x\": 246}, \"lower_lip_20\": {\"y\": 332, \"x\": 239}, \"lower_lip_21\": {\"y\": 331, \"x\": 241}, \"lower_lip_26\": {\"y\": 323, \"x\": 252}, \"lower_lip_27\": {\"y\": 322, \"x\": 254}, \"lower_lip_24\": {\"y\": 327, \"x\": 248}, \"lower_lip_25\": {\"y\": 325, \"x\": 250}, \"lower_lip_28\": {\"y\": 320, \"x\": 256}, \"lower_lip_29\": {\"y\": 318, \"x\": 258}}}, \"face_rectangle\": {\"width\": 225, \"top\": 161, \"height\": 224, \"left\": 119}}}";
            Poco::JSON::Parser parser;
            const Dynamic::Var &var = parser.parse(stRes);
            if(!var.isEmpty()){
                const JSON::Object::Ptr resObj = var.extract<Poco::JSON::Object::Ptr>();
                const JSON::Object::Ptr landmarkObj = resObj->getObject("face")->getObject("landmark");
                const JSON::Object::Ptr mouth = landmarkObj->getObject("mouth");
                //画出眉毛轮廓
                std::vector<cv::Point> lowerContours;
                std::vector<cv::Point> upperContours;
                //找出眼周leftContours中x坐标最大,最小值;y最大最小值
                int x_min = 0x7FFFFFFF,x_max=0,y_min = 0x7FFFFFFF,y_max=0;
                for(int i=0;i<64;++i){
                    const JSON::Object::Ptr &pPtr = mouth->getObject("upper_lip_" + to_string(i));
                    int x = pPtr->get("x");
                    int y = pPtr->get("y");
                    if(x>x_max){
                        x_max = x;
                    }
                    if(x<x_min){
                        x_min = x;
                    }
                    if(y>y_max){
                        y_max = y;
                    }
                    if(y<y_min){
                        y_min = y;
                    }
//                    circle(mat,cv::Point(x,y),1,cv::Scalar(0,0,255));
                    upperContours.push_back(cv::Point(x,y));
                }
                for(int i=0;i<64;++i){
                    const JSON::Object::Ptr &pPtr = mouth->getObject("lower_lip_" + to_string(i));
                    int x = pPtr->get("x");
                    int y = pPtr->get("y");
                    if(x>x_max){
                        x_max = x;
                    }
                    if(x<x_min){
                        x_min = x;
                    }
                    if(y>y_max){
                        y_max = y;
                    }
                    if(y<y_min){
                        y_min = y;
                    }
//                    circle(mat,cv::Point(x,y),1,cv::Scalar(0,0,255));
                    lowerContours.push_back(cv::Point(x,y));
                }


//                vector<unsigned char> data;
//                ifstream ifs("/Users/edz/CLionProjects/AI_Face/sk2.png",ios::binary);
//                char buf[1024];
//                while(ifs.read(buf, sizeof(buf))){
//                    streamsize gcount = ifs.gcount();
//                    for (int i = 0; i < gcount; ++i){
//                        data.push_back(buf[i]);
//                    }
//                }
//                streamsize gcount = ifs.gcount();
//                if(gcount>0){
//                    for (int i = 0; i < gcount; ++i){
//                        data.push_back(buf[i]);
//                    }
//                }
                cv::Mat& lipsLut = lipsLutMap[mtIndex];

                cout << "lipsLut.rows=" << lipsLut.rows << endl;
                cout << "lipsLut.cols=" << lipsLut.cols << endl;
                cout << "lipsLut.channels=" << lipsLut.channels() << endl;

                int height = mat.rows;
                int width = mat.cols;
                int stride = mat.channels();
                uchar* srcData = mat.data;
                uchar* lipsColorMap = lipsLut.data;
                for(int n = 0; n < height; n++)
                {
                    for(int m = 0; m < width; m++)
                    {
                        if(m>=x_min and m<=x_max and n>=y_min and n<=y_max
                        and (cv::pointPolygonTest(lowerContours,cv::Point(m,n),false)!=-1)
                        or (cv::pointPolygonTest(upperContours,cv::Point(m,n),false)!=-1))
                        {
                            //get alpha for blend
                            int pos = width * n * stride + m * stride;
                            int b = srcData[pos];
                            int g = srcData[pos + 1];
                            int r = srcData[pos + 2];
                            //lips recolored using 512 lut
                            int k  =  (b  >>  2);
                            int nx  =  (int)(r  >>  2)  +  ((k  -  ((k  >>  3)  <<  3))  <<  6);
                            int ny  =  (int)(((b  >>  5)  <<  6)  +  (g  >>  2));
                            int mpos  =  (nx * 3)  +  (ny * 512 * 3);
                            int mb = lipsColorMap[mpos];
                            int mg = lipsColorMap[mpos + 1];
                            int mr = lipsColorMap[mpos + 2];
                            //lips and color blend by alpha
                            srcData[pos] = CLIP3(mb, 0, 255);
                            srcData[pos + 1] = CLIP3(mg, 0, 255);
                            srcData[pos + 2] = CLIP3(mr, 0, 255);
                        }
                    }
                }






                cv::cvtColor(mat,mat,cv::COLOR_BGRA2BGR);
                imshow("美眉",mat);
                cout << "time cost:" << stopwatch.elapsed()/1000 << " ms" << endl;
//                imshow("lipsLut",lipsLut);
                waitKey(0);
            }
        }

    }else{
        return 1;
    }
    return 0;
}
